'use strict';

var Replacer = require('regexp-sourcemaps');
var through = require('through2');
var applySourceMap = require('vinyl-sourcemaps-apply');

var regexpStream = module.exports = function(regexp, replace, name) {
  var replacer = new Replacer(regexp, replace, name);
  return through.obj(function(file, enc, cb) {
    if (file.isNull())
      return cb(null, file);

    if (file.isStream())
      return this.emit('error', new Error('gulp-regexp-sourcemaps: does not support streams in vinyls'));

    var result = replacer.replace(file.contents.toString('utf8'), file.relative);
    file.contents = new Buffer(result.code);

    if (file.sourceMap)
      applySourceMap(file, result.map);

    cb(null, file);
  });
};
